
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Training and Simulation &#8212; Battery SOH  documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="../_static/css/custom.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Report related" href="Report.html" />
    <link rel="prev" title="LSTMs with chemistry" href="LSTMchem.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 current active nav-item">
 <a class="current reference internal nav-link" href="#">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                

<nav id="bd-toc-nav">
    
</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <div class="section" id="training-and-simulation">
<h1>Training and Simulation<a class="headerlink" href="#training-and-simulation" title="Permalink to this headline">¶</a></h1>
<p>Corresponds to the <code class="docutils literal notranslate"><span class="pre">Training</span></code> module</p>
<span class="target" id="module-Training"></span><dl class="py function">
<dt class="sig sig-object py" id="Training.Train">
<span class="sig-prename descclassname"><span class="pre">Training.</span></span><span class="sig-name descname"><span class="pre">Train</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">train_loader</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">valid_loader</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">model</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">N_epochs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">loss_fn</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">optimizer</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">parameters</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">LR</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">5e-06</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">print_bool</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">remove_bool</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">file_name</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'TEST'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">report_name</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">sim_loader</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">Training_info</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">device</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'cpu'</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwargs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Training.html#Train"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Training.Train" title="Permalink to this definition">¶</a></dt>
<dd><p>Function for training pytorch neural network models.
It takes in two DataLoader classes, for the training and validation sets,
a torch.nn.Module model, the number of epochs and the learning rate. From
that, it trains the model and automatically calculates what the best epoch
was.</p>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>You may find references about this function’s <code class="docutils literal notranslate"><span class="pre">report</span></code> or
<code class="docutils literal notranslate"><span class="pre">plot_bool</span></code> arguments in some parts of the documentation.
They are deprecated since August 18th 2021 (they don’t appear in the
function anymore). The function will act as if they were <code class="docutils literal notranslate"><span class="pre">True</span></code>.</p>
<p>The code still works if you include them in the arguments, it will just
show a warning (except in google colab because it apparently suppresses
warnings).</p>
<p>The <code class="docutils literal notranslate"><span class="pre">report</span></code> argument in <a class="reference internal" href="#Training.simulate" title="Training.simulate"><code class="xref py py-func docutils literal notranslate"><span class="pre">simulate()</span></code></a> is still useful
and used.</p>
</div>
<p>A report folder is created inside the “Reports” directory (if it doesn’t
exist one is created). The user can add a name to the specific report folder
through the <code class="docutils literal notranslate"><span class="pre">report_name</span></code> argument. Either way, the name is followed by
the date and time of the training in order to avoid overwriting.</p>
<p>To know more about report folder, check the documentation for
<a class="reference internal" href="Report.html"><span class="doc">Report related</span></a>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>report_name</strong> (<em>str</em><em>, </em><em>optional</em>) – </p></li>
<li><p><strong>train_loader</strong> (<em>torch.utils.data.DataLoader</em>) – The training dataset’s DataLoader class.</p></li>
<li><p><strong>valid_loader</strong> (<em>torch.utils.data.DataLoader</em>) – The validation dataset’s DataLoader class.</p></li>
<li><p><strong>model</strong> (<em>torch.nn.Module</em>) – The model to be trained.</p></li>
<li><p><strong>N_epochs</strong> (<em>int</em>) – The number of epochs.</p></li>
<li><p><strong>loss_fn</strong> (<em>th.nn Loss function</em><em>, </em><em>optional</em>) – The loss function.</p></li>
<li><p><strong>optimizer</strong> (<em>th.nn Optimizer</em><em>, </em><em>optional</em>) – The optimizer.</p></li>
<li><p><strong>LR</strong> (<em>float</em><em>, </em><em>default = 5e-6</em>) – The learning rate.</p></li>
<li><p><strong>print_bool</strong> (<em>bool</em><em>, </em><em>default = False</em>) – If we want to print the epochs’ losses during calculation.</p></li>
<li><p><strong>file_name</strong> (<em>str</em><em>, </em><em>default = 'TEST'</em>) – The file name to be added to the report and image files.</p></li>
<li><p><strong>report_name</strong> – A name to add before the date in the report name.</p></li>
<li><p><strong>sim_loader</strong> (<em>torch.utils.data.DataLoader</em><em>, </em><em>optional</em>) – A DataLoader to be simulated during training, plotted in “real time” as
the model learns. Not a necessary input,
of course.</p></li>
<li><p><strong>Training_info</strong> (<a class="reference internal" href="Report.html#Report.Training_Class" title="Report.Training_Class"><em>Training_Class</em></a><em>, </em><em>optional</em>) – A Training_Class object to keep track of the training.
Only entered as input if the model has already been trained.</p></li>
<li><p><strong>device</strong> (<em>torch.device</em><em>, </em><em>default = 'cpu'</em>) – The device where the training should be run.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><ul class="simple">
<li><p><strong>Training_info</strong> (<em>Training_Class</em>) – The Training_Class object with all of the information related to the
training.</p></li>
<li><p><strong>Total_error[-1]</strong> (<em>torch.Tensor([float])</em>) – Last epoch’s training error.</p></li>
<li><p><strong>Valid_error[-1]</strong> (<em>torch.Tensor([float])</em>) – Last epoch’s validation error [float]</p></li>
<li><p><strong>date</strong> (<em>str</em>) – The date and time at the beginning of the training. This is the name of
the report when <code class="docutils literal notranslate"><span class="pre">report=True</span></code></p></li>
</ul>
</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="o">*</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">delta</span> <span class="o">=</span> <span class="mi">10</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">hidden_dim</span> <span class="o">=</span> <span class="mi">20</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">version</span> <span class="o">=</span> <span class="mi">4</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">model</span> <span class="o">=</span> <span class="n">LSTM_v4</span><span class="p">(</span><span class="n">delta</span><span class="p">,</span> <span class="n">hidden_dim</span><span class="p">,</span> <span class="n">pooling_layer</span><span class="o">=</span><span class="s1">&#39;bi_mean&#39;</span><span class="p">,</span> <span class="n">version</span><span class="o">=</span><span class="n">version</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">([</span><span class="n">Battery</span><span class="p">],</span> <span class="n">delta</span><span class="p">,</span> <span class="n">version</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">train_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">train_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">shuffle</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;B0006.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">valid_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">([</span><span class="n">Battery</span><span class="p">],</span> <span class="n">delta</span><span class="p">,</span> <span class="n">version</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">valid_loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">valid_dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">valid_dataset</span><span class="p">),</span>
<span class="gp">... </span><span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">N_epochs</span> <span class="o">=</span> <span class="mi">2</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">Learning_Rate</span> <span class="o">=</span> <span class="mf">1e-5</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">Train</span><span class="p">(</span><span class="n">train_loader</span><span class="p">,</span> <span class="n">valid_loader</span><span class="p">,</span> <span class="n">model</span><span class="p">,</span> <span class="n">N_epochs</span><span class="p">,</span> <span class="n">loss_fn</span><span class="o">=</span><span class="n">nn</span><span class="o">.</span><span class="n">L1Loss</span><span class="p">(),</span>
<span class="gp">... </span><span class="n">optimizer</span><span class="o">=</span><span class="n">th</span><span class="o">.</span><span class="n">optim</span><span class="o">.</span><span class="n">Adam</span><span class="p">(</span><span class="n">model</span><span class="o">.</span><span class="n">parameters</span><span class="p">(),</span> <span class="n">Learning_Rate</span><span class="p">),</span>
<span class="gp">... </span><span class="n">LR</span> <span class="o">=</span> <span class="n">Learning_Rate</span><span class="p">)</span>
<span class="go">1 . Training loss:  tensor(0.8822)</span>
<span class="go">1 . Validation loss:  tensor(0.5137)</span>
<span class="go">2 . Training loss:  tensor(0.8365)</span>
<span class="go">2 . Validation loss:  tensor(0.4762)</span>
</pre></div>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="Training.simulate">
<span class="sig-prename descclassname"><span class="pre">Training.</span></span><span class="sig-name descname"><span class="pre">simulate</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">sim_loader</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">model</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">report</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">plot_bool</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">file_name</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'Capacity'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">device</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'cpu'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">Time_stamps</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">block</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">denormalize</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">title</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'Simulation'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dir_name</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">''</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fixed_lims</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Training.html#simulate"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Training.simulate" title="Permalink to this definition">¶</a></dt>
<dd><p>Function for simulating a model’s performance on a dataset.
This will create a plot where the model’s outputs are shown in blue and the
labels/real values are shown in orange.</p>
<p>If report = True, then it will save the plot as an image in the “Images”
folder.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>sim_loader</strong> (<em>torch.utils.data.DataLoader</em>) – The dataset’s DataLoader.</p></li>
<li><p><strong>model</strong> (<em>torch.nn.Module</em>) – The model we want to test.</p></li>
<li><p><strong>report</strong> (<em>bool</em><em>, </em><em>default = False</em>) – Whether or not we want to save an image of the simulation.</p></li>
<li><p><strong>plot_bool</strong> (<em>bool</em><em>, </em><em>default = True</em>) – Whether or not we want to show the plot.</p></li>
<li><p><strong>file_name</strong> (<em>str</em><em>, </em><em>default = Capacity</em>) – File name for the saved plot.</p></li>
<li><p><strong>device</strong> (<em>torch.device</em><em> or </em><em>str</em><em>, </em><em>default = 'cpu'</em>) – The device where we want to do the calculations on.</p></li>
<li><p><strong>Time_stamps</strong> (<em>array_like</em><em>, </em><em>optional</em>) – Dataset’s time stamps.</p></li>
<li><p><strong>block</strong> (<em>bool</em><em>, </em><em>default = True</em>) – Whether or not the plot should stop the code from continuing.
if block == False, then the plot will be shown for 5 seconds.</p></li>
<li><p><strong>denormalize</strong> (<em>bool</em><em>, </em><em>default = True</em>) – Whether or not we want the plot to show the de-normalized values or not.
if denormalize == False, then the plot will show the model’s output and
the labels in their normalized form.</p></li>
<li><p><strong>title</strong> (<em>str</em><em>, </em><em>default = 'Simulation'</em>) – The plot’s title.</p></li>
<li><p><strong>dir_name</strong> (<em>str</em><em>, </em><em>optional</em>) – A string to add to the Image directory name in order to differentiate
it. For instance, if dir_name=’_Final’ then the images will be saved in
directory ‘Images_Final’ (if the directory doesn’t exist it will be
created).</p></li>
<li><p><strong>fixed_lims</strong> (<em>bool</em><em>, </em><em>default = True</em>) – Whether or not to fix the y-axis limits between -0.1 and 1.1.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                
    <a class='left-prev' id="prev-link" href="LSTMchem.html" title="previous page">LSTMs with chemistry</a>
    <a class='right-next' id="next-link" href="Report.html" title="next page">Report related</a>

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>